<?php

class db_mysql {
	public $pdo;
	public $arrSql;
	public $Statement;
	public function getArray($sql)
	{
		if(!$result = $this->query($sql))return array();
		if(!$this->Statement->rowCount())return array();
		$rows = array();
		while($rows[] = $this->Statement->fetch(PDO::FETCH_ASSOC)){}
		$this->Statement=null;
		array_pop($rows);
		return $rows;
	}

	public function newinsertid()
	{
		return $this->pdo->lastInsertId();
	}
	
	public function showtables($tables)
	{
		$this->query("show tables like '%".$tables."%'");
		return $this->Statement->rowCount();
	}

	public function setlimit($sql, $limit)
	{
		return $sql. " LIMIT {$limit}";
	}

    public function query($sql)
    {
		$this->arrSql[] = $sql;
        $this->Statement = $this->pdo->query($sql);
        if ($this->Statement) {
			return $this;
			//return $this->Statement->execute();
        }else $this->errorMessage();
    }
	
	public function exec($sql)
	{
		$this->arrSql[] = $sql;
        if(!$this->pdo->exec($sql))$this->errorMessage(); 
		return true;
	}
	//影响行数
	public function affected_rows()
	{
		return $this->Statement->rowCount();
	}

	public function getTable($tbl_name)
	{
		return $this->getArray("DESCRIBE {$tbl_name}");
	}

	public function __construct($dbConfig)
	{
		class_exists('PDO') or exit("not found PDO");
		$this->pdo = new PDO("mysql:host=".$dbConfig['host'].";port=".$dbConfig['port'].";dbname=".$dbConfig['database'],$dbConfig['login'], $dbConfig['password']); 
		if(!$this->pdo){
				echo '<meta http-equiv="Content-Type" content="text/html; charset=utf-8" />数据库无法链接，如果您是第一次使用，请先执行<a href="install">安装程序</a>';exit;
		}
		$this->exec("SET NAMES UTF8");
	}
	
	public function __val_escape($value) {
		return '\''.$value.'\'';
	}

	public function __destruct()
	{
		//if( TRUE != $GLOBALS['G_DY']['db']['persistent'] )@mysql_close($this->pdo);
		if( TRUE != $GLOBALS['G_DY']['db']['persistent'] )$this->pdo=null;
	}
	
	public function errorMessage()
    {
        
		$msg = $this->pdo->errorInfo();
        if($msg[2]) syError('数据库错误：' . $msg[2] . end($this->arrSql));
		//echo "未知错误！";exit;
	}
}

